package KeyFramer;

public class animationPoint {
	
	// private variables
	String myPointName = ""; // name of this animation point
	animationVectors myAnimationVectors = new animationVectors();
	
	
	
	// contructor
	public animationPoint(String scriptLine)
	{
		// split this contruction line and build up this object
		String[] parts = scriptLine.split(":");
		
		// part 0 is the name
		myPointName = parts[1];
		
		// the rest of line comes in groups of four
		for(int i = 2 ; i < parts.length; i = i + 4)
		{
			myAnimationVectors.addAnimationVector(new animationVector(parts[i],parts[i+1],parts[i+2],parts[i+3]));
		}
	}

	//process a line for substitution
	public String processLine(String line,int frame)
	{
		String returnValue = line;
		
		float v = getValueForFrame(frame);
		returnValue = returnValue.replaceAll(getAnimationPointName(),String.valueOf(getValueForFrame(frame)));
		
		return returnValue;
	}
	
	public float getValueForFrame(int frame)
	{
		float returnValue = 0f;
		boolean foundValue = false;
		
		for(int i = 0 ; i < myAnimationVectors.getCount() ; i++)
		{
			if(frame >= myAnimationVectors.getAnimationVectorByIndex(i).getStartFrame() && frame <= myAnimationVectors.getAnimationVectorByIndex(i).getEndFrame())
			{
				foundValue = true;
				returnValue = myAnimationVectors.getAnimationVectorByIndex(i).getValueForFrame(frame);
				break;
			}
		}
		
		// the frame does not fall in a specified range
		if(foundValue == false)
		{
			
			int lowestFrame = getLowestVectorFrame();
			int highestFrame = getHighestVectorFrame();
			if(frame < lowestFrame)
			{
				returnValue = myAnimationVectors.getAnimationVectorByIndex(lowestFrame).getStartValue();
			}
			else
			{
				returnValue = myAnimationVectors.getAnimationVectorByIndex(highestFrame).getEndValue();
			}
			
		}
		
		return returnValue;
	}
	
	public int getLowestVectorFrame()
	{
		int returnValue = 99999999;
		for(int i = 0 ; i < myAnimationVectors.getCount() ; i++)
		{
			if(myAnimationVectors.getAnimationVectorByIndex(i).getStartFrame() < returnValue)
			{
				returnValue = i; 
			}
		}
		return returnValue;
	
	}

	public int getHighestVectorFrame()
	{
		int returnValue = -99999999;
		for(int i = 0 ; i < myAnimationVectors.getCount() ; i++)
		{
			if(myAnimationVectors.getAnimationVectorByIndex(i).getEndFrame() > returnValue)
			{
				returnValue = i; 
			}
		}
		return returnValue;
	
	}
	
	// property accessors
	public String getAnimationPointName()
	{
		return myPointName;
	}



}
